
#include <list>
#include <set>

// e\bhɂAu₩̑IvNXQ
// TID|C^Aj[N\łȂ΂ȂȂB


// l
#define INVALID_VALUE NULL
//#define INVALID_VALUE -1



// ----------------------------------------------------------------------
// e\bh̒ۊNX
template<typename T>
class OverlapController
{
public:
	OverlapController() {}
	virtual ~OverlapController() {}

	// ₩I
	// ͈ȏ゠邱Ƃۏ؂ĂB
	virtual T select(const list<T>&) =0;


	// Cxgʒmnh

	// ₪ǉꂽ
	virtual void on_add(const list<T>& i_candidates, typename list<T>::const_iterator i_it) {}
	// ₪悤ƂĂ
	virtual void on_erase(const list<T>& i_candidates, typename list<T>::const_iterator i_it) {}
	// d󋵂
	virtual void on_clear() {}
};

// ----------------------------------------------------------------------
// S_
template<typename T>
class OC_Random : public OverlapController<T>
{
public:
	// ₩I
	virtual T select(const list<T>& i_candidates)
	{
		typename list<T>::const_iterator it = i_candidates.begin();
		advance( it, random() % i_candidates.size() );
		return *it;
	}
};

// ----------------------------------------------------------------------
// SĎg؂܂ŏd
template<typename T>
class OC_NonOverlap : public OverlapController<T>
{
	set<T> m_used;
	set<T> m_unused;
public:
	// ₩I
	virtual T select(const list<T>&)
	{
		// ugpvۂȂugpς݁vSāugpvɂB
		if ( m_unused.empty() )
		{
			m_used.swap( m_unused );
		}

		// ugpv烉_ɈIяo
		typename set<T>::iterator it = m_unused.begin();
		advance( it, random() % m_unused.size() );

		// I񂾈ugpvugpς݁vɈڂ
		T t = *it;
		m_unused.erase(it);
		m_used.insert(t);

		return t;
	}

	// ₪ǉꂽ
	virtual void on_add(const list<T>&, typename list<T>::const_iterator i_it)
	{
		m_unused.insert(*i_it);
	}

	// ₪悤ƂĂ
	virtual void on_erase(const list<T>&, typename list<T>::const_iterator i_it)
	{
		// ݂ǂɂ邩킩Ȃ̂ŁAɎwo
		m_unused.erase(*i_it);
		m_used.erase(*i_it);
	}
	
	// d󋵂
	virtual void on_clear() 
	{
		for ( typename set<T>::const_iterator it = m_used.begin() ; it != m_used.end() ; ++it )
		{
			m_unused.insert(*it);
		}
		m_used.clear();
	}
};

// ----------------------------------------------------------------------
// OƂ̏d͉
template<typename T>
class OC_NonDual : public OverlapController<T>
{
	T m_last;
public:
	OC_NonDual() : m_last(INVALID_VALUE) {}

	// ₩I
	virtual T select(const list<T>& i_candidates)
	{
		// Ȃ̂悤Ȃ
		if ( i_candidates.size() == 1 )
		{
			return *(i_candidates.begin());
		}
		
		// _ɈI
		typename list<T>::const_iterator it = i_candidates.begin();
		advance( it, random() % i_candidates.size() );
		
		if ( m_last != INVALID_VALUE )
		{
			// O΁AO͔B
			if ( m_last == *it )
			{
				++it;
				if ( it == i_candidates.end() )
				{
					it = i_candidates.begin();
				}
			}
		}

		return (m_last = *it);
	}

	// ₪悤ƂĂ
	virtual void on_erase(const list<T>& i_candidates, typename list<T>::const_iterator i_it)
	{
		if ( m_last == *i_it ) 
			m_last = INVALID_VALUE;
	}
	
	// d󋵂
	virtual void on_clear() 
	{
		m_last = INVALID_VALUE;
	}
};


// ----------------------------------------------------------------------
// ~
template<typename T>
class OC_Sequential : public OverlapController<T>
{
	T m_last;
public:
	OC_Sequential() : m_last(INVALID_VALUE) {}

	// ₩I
	virtual T select(const list<T>& i_candidates)
	{
		typename list<T>::const_iterator it = i_candidates.begin();
		if ( m_last != INVALID_VALUE )
		{
			while ( m_last != *it )
			{
				++it;
			}
			assert( m_last == *it );

			// Ô̂Pi߂
			if ( ++it == i_candidates.end() )
			{
				it = i_candidates.begin();
			}
		}
		return (m_last = *it);
	}

	// ₪悤ƂĂ
	virtual void on_erase(const list<T>& i_candidates, typename list<T>::const_iterator& i_it)
	{
		if ( m_last == *i_it ) 
		{
			if ( i_it == i_candidates.begin() )
			{
				i_it = i_candidates.end();
			}
			m_last = *(--i_it);
		}
	}
	
	// d󋵂
	virtual void on_clear() 
	{
		m_last = INVALID_VALUE;
	}
};

// ----------------------------------------------------------------------
// 
template<typename T>
class OC_SequentialDesc : public OverlapController<T>
{
	T m_last;
public:
	OC_SequentialDesc() : m_last(INVALID_VALUE) {}

	// ₩I
	virtual T select(const list<T>& i_candidates)
	{
		typename list<T>::const_reverse_iterator it = i_candidates.rbegin();
		if ( m_last != INVALID_VALUE )
		{
			while ( m_last != *it )
			{
				++it;
			}
			assert( m_last == *it );

			// Ô̂Pi߂
			if ( ++it == i_candidates.rend() )
			{
				it = i_candidates.rbegin();
			}
		}
		return (m_last = *it);
	}

	// ₪悤ƂĂ
	virtual void on_erase(const list<T>& i_candidates, typename list<T>::const_iterator& i_it)
	{
		if ( m_last == *i_it ) 
		{
			++i_it;
			if ( i_it == i_candidates.end() )
			{
				i_it = i_candidates.begin();
			}
			m_last = *i_it;
		}
	}
	
	// d󋵂
	virtual void on_clear() 
	{
		m_last = INVALID_VALUE;
	}
};


#undef INVALID_VALUE

