#include	"satori.h"

#ifdef POSIX
/* POSIXłstricmp͒`ĂȂBstrcasecmpgB */
#  define stricmp strcasecmp
#  include <string.h>
#endif

int	Satori::request(
	const string& i_protocol,
	const string& i_protocol_version,
	const string& i_command,
	const strpairvec& i_data,
	
	string& o_protocol,
	string& o_protocol_version,
	strpairvec& o_data)
{
	//-------------------------------------------------
	// NGXgPʂ̃NXo

	mRequestMap.clear();
	mRequestID = "";
	mReferences.clear();
	mReferences.resize(8); // ŏl

	// NXoɐݒ
	mRequestCommand = i_command;
	mRequestType = i_protocol;
	mRequestVersion = i_protocol_version;
	mStatusLine = i_command + " " + i_protocol + "/" + i_protocol_version;

	// ԂvgR̃ftHgl
	o_protocol = "SHIORI";
	o_protocol_version = "3.0";

	// vgR𔻕
	if ( i_protocol=="SAORI" && i_protocol_version[0]>='1' )
	{
		o_protocol = i_protocol;
		o_protocol_version = "1.0";
		mRequestMode = SAORI;
	}
	else if ( i_protocol=="SHIORI" && i_protocol_version[0]>='3' )
	{
		mRequestMode = SHIORI3;
	}
	else if ( i_protocol=="SHIORI" && i_protocol_version[0]=='2' )
	{
		mRequestMode = SHIORI2;
			// 2.xɂo[WƂĂ3.0Ԃ
	}
	else if ( i_protocol=="MAKOTO" && i_protocol_version[0]>='2' )
	{
		o_protocol = i_protocol;
		o_protocol_version = "2.0";
		mRequestMode = MAKOTO2;
	}
	else if ( i_protocol=="UNKNOWN" )
	{
		mRequestMode = UNKNOWN;
	}
	else
	{
		// Ή̃vgRB
		return	400;
	}

	// f[^mRequestMapɊi[B
	// SHOIRI/3.0ȊÕvgȐꍇASHOIRI/3.0ɕϊsB
	for ( strpairvec::const_iterator it = i_data.begin() ; it != i_data.end() ; ++it )
	{
		string key = it->first;
		const string& value = it->second;

		switch ( mRequestMode ) {
		case SAORI:
			if ( compare_head(key, "Argument") ) {
				int	n = stoi(key.c_str()+8);
				if ( n==0 )
					key = "ID";
				else
					key = "Reference" + itos(n-1);
			}
			break;
		case SHIORI2:	// ͂ĂƁ[
			if ( key=="Event" )
				key="ID";
			break;
		case MAKOTO2:
			if ( key=="String" )
				key="Reference0";
			break;
		default:
			break;
		}

		mRequestMap[key] = value;
		if ( compare_head(key, "Reference") ) {
			int	n = stoi(key.c_str()+9);
			if ( n>=0 && n<65536 ) {
				if ( n>=mReferences.size() )
					mReferences.resize(n+1);
				mReferences[n]=value;
			}
		}
	}

	if ( mRequestMode == MAKOTO2 )
	{
		mRequestMap["ID"] = "OnMakoto";
	}

	mRequestID = mRequestMap["ID"];
	mIsMateria = ( mRequestMap["Sender"] == "embryo" );


	//-------------------------------------------------
	// NGXg

	if ( mRequestCommand=="GET Version" )
	{
		if ( mRequestMode == SHIORI2 )
		{
			o_data.push_back( strpair("ID", gSatoriName) );
			o_data.push_back( strpair("Craftman", gSatoriCraftman) );
			o_data.push_back( strpair("Version", gSatoriVersion) );
		}
		return 200;
	}


	// I𕪊L^ϐɑBref0ɖ߂B
	if ( compare_head(mRequestID, "OnChoice") ) // OnChoiceSelect/OnChoiceEnter̗
	{
		strvec	vec;
		int	ref_no = ( mRequestID=="OnChoiceEnter" )?1:0;
		string&	info = mRequestMap[string("Reference")+itos(ref_no)];
		if ( split(info, byte1_dlmt, vec)==3 ) // \1؂̂RłȂ
		{
			info=mReferences[ref_no]=variables["Ihc"]=vec[0];
			variables["Ix"]=vec[1];
			variables["Iԍ"]=vec[2];
		}
	}

	// OɂĐFX
	bool	logmode = !( mRequestID=="OnSurfaceChange" || mRequestID=="OnSecondChange"
		|| mRequestID=="OnMouseMove" || mRequestID=="OnTranslate" 
		/*|| compare_tail(mRequestID, "caption")*/ || compare_tail(mRequestID, "visible")
		|| compare_head(mRequestID, "menu.") || mRequestID.find(".color.")!=string::npos );

	if(fRequestLog && logmode)
	{
		sender << "--- Request ---" << endl << mStatusLine << endl; // << iRequest << endl;
		for(strmap::iterator i=mRequestMap.begin() ; i!=mRequestMap.end() ; ++i)
			if ( !i->first.empty() && !i->second.empty()
				&& i->first!="SecurityLevel" 
				&& i->first!="Sender" 
				&& i->first!="Charset" )
				sender << i->first << ": " << i->second << endl;
	}

	// ゠H
	strmap::const_iterator it = mRequestMap.find("SecurityLevel");
	secure_flag = ( it!=mRequestMap.end() && stricmp(it->second.c_str(), "local")==0 );

	// C
	Sender::validate( fOperationLog && logmode );
	sender << "--- Operation ---" << endl;
	int	status_code = CreateResponse(mResponseMap);

	// ㏈P
	default_surface = next_default_surface;

	//--------------------------------------------------------------------

	// Valueɑ΂ŏI
	if ( status_code==200 ) {	// && compare_head(mRequestID, "On")
		strmap::iterator i = mResponseMap.find("Value");
		if ( i!=mResponseMap.end() ) {
			if ( !Translate(i->second) ) {
				status_code = 204;
				mResponseMap.erase(i);
			} 
			else {
				second_from_last_talk = 0;
				if ( compare_head(mRequestID, "On") ) {
					mResponseHistory.push_front(i->second);
					if ( mResponseHistory.size() >= RESPONSE_HISTORY_SIZE )
						mResponseHistory.pop_back();
				}
			}
		}
	}

	sender << "status code : " << itos(status_code) << endl;

	//--------------------------------------------------------------------

	for(strmap::const_iterator i=mResponseMap.begin() ; i!=mResponseMap.end() ; ++i)
	{
		string	key=i->first, value=i->second;

		switch ( mRequestMode ) {
		case SAORI:
			if ( key=="Value" )
				key = "Result";
			else if ( compare_head(key, "Reference") )
				key = string() + "Value" + (key.c_str()+9);
			break;
		case SHIORI2:
			if ( key=="Value" )
				key = "Sentence";
			break;
		case MAKOTO2:
			if ( key=="Value" )
				key = "String";
			break;
		default:
			break;
		}
		o_data.push_back( strpair(key, value) );
	}

	Sender::validate();
	if(fResponseLog && logmode)
	{
		sender << "--- Response ---" << endl << mResponseMap << endl;
	}
	mResponseMap.clear();

	//--------------------------------------------------------------------

	// [h
	if ( reload_flag )
	{
		reload_flag = false;
		string	tmp = mBaseFolder;
		sender << "reloading." << endl;
		unload();
		load(tmp);
		sender << "reloaded." << endl;
	}

	return	status_code;
}
