#ifdef _MSC_VER 

	// }`j^֘A
	//#define WINVER 0x0500
	#include	<windows.h>
	#include	<multimon.h>
	#define SM_CXVIRTUALSCREEN      78
	#define SM_CYVIRTUALSCREEN      79

#endif	// _MSC_VER


#include	"satori.h"

#include	<fstream>
#include	<cassert>
#include	<ctime>	// for randomize

#include	"../_/Utilities.h"
#include	"../_/stltool.h"

#ifdef POSIX
#  include      "posix_utils.h"
#endif


//---------------------------------------------------------------------------
#ifndef POSIX
BOOL CALLBACK MonitorEnumFunc(HMONITOR hMonitor,HDC hdc,LPRECT rect,LPARAM lParam) {

    MONITORINFOEX MonitorInfoEx;
    MonitorInfoEx.cbSize=sizeof(MonitorInfoEx);

	BOOL (WINAPI* pGetMonitorInfo)(HMONITOR,LPMONITORINFO);
	(FARPROC&)pGetMonitorInfo = ::GetProcAddress(::LoadLibrary("user32.dll"), "GetMonitorInfoA");
	if ( pGetMonitorInfo==NULL )
		return	FALSE;
	if ( !(*pGetMonitorInfo)(hMonitor,&MonitorInfoEx) ) {
		sender << "'GetMonitorInfo' was failed." << endl;
        return FALSE;
    }

	sender << "j^: " << MonitorInfoEx.szDevice << " / (" << 
		rect->left << "," << rect->top << "," << rect->right << "," << rect->bottom << ") / " <<
		((MonitorInfoEx.dwFlags==MONITORINFOF_PRIMARY) ? "primary" : "extra") << endl;

	RECT&	max_screen_rect = *((RECT*)lParam);
	if ( rect->left < max_screen_rect.left )
		max_screen_rect.left = rect->left;
	if ( rect->top < max_screen_rect.top )
		max_screen_rect.top = rect->top;
	if ( rect->right > max_screen_rect.right )
		max_screen_rect.right = rect->right;
	if ( rect->bottom > max_screen_rect.bottom )
		max_screen_rect.bottom = rect->bottom;

    return TRUE;
}
#endif

//---------------------------------------------------------------------------

#ifdef	_DEBUG
	//memory leaǩo(3s̏ԂŋLqĂB)
	#define _CRTDBG_MAP_ALLOC
	#include <stdlib.h>
	#include <crtdbg.h>
#endif // _DEBUG

bool	Satori::load(const string& iBaseFolder)
{
	Sender::initialize();

#ifdef	_DEBUG
	int tmpDbgFlag;
	tmpDbgFlag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);
	tmpDbgFlag |= _CRTDBG_ALLOC_MEM_DF;
	tmpDbgFlag |= _CRTDBG_LEAK_CHECK_DF;
	_CrtSetDbgFlag(tmpDbgFlag);
#endif // _DEBUG


	mBaseFolder = iBaseFolder;
	sender << "SATORI::Load on " << mBaseFolder << "" << endl;

#if POSIX
	// u/vŏIĂȂΕtB
	if (mBaseFolder[mBaseFolder.size() - 1] != '/') {
	    mBaseFolder += '/';
	}
#endif


#ifdef	_MSC_VER
	// {̂̂tH_T[`
	{
		TCHAR	buf[MAX_PATH+1];
		::GetModuleFileName(NULL, buf, MAX_PATH);
		char*	p = FindFinalChar(buf, DIR_CHAR);
		if ( p==NULL )
			mExeFolder = "";
		else {
			*(++p) = '\0';
			mExeFolder = buf;
		}
	}
	sender << "{̂̏: " << mExeFolder << "" << endl;
#endif // _MSC_VER

	// o
	InitMembers();

#ifdef	_MSC_VER
	// VXe̐ݒǂł
    OSVERSIONINFO	ovi;
    ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	::GetVersionEx(&ovi);
	string	os;
	if ( ovi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS ) {
		if ( ovi.dwMinorVersion == 0 ) { mOSType=WIN95; os="Windows 95"; }
		else if ( ovi.dwMinorVersion == 10 ) { mOSType=WIN98; os="Windows 98"; }
		else if ( ovi.dwMinorVersion == 90 ) { mOSType=WINME; os="Windows Me"; }
		else { mOSType = UNDEFINED; os="undefined"; }
	} else {
		if ( ovi.dwMinorVersion == 0 ) {
			if ( ovi.dwMajorVersion == 4 ) { mOSType=WINNT; os="Windows NT"; }
			else if ( ovi.dwMajorVersion == 5 ) { mOSType=WIN2K; os="Windows 2000"; }
		}
		else { mOSType = WINXP; os="Windows XP or later"; }
	}
	sender << "nr: " << os << endl;
	if ( mOSType==WIN95 ) {
		is_single_monitor = true;
	} else {
		BOOL (WINAPI* pEnumDisplayMonitors)(HDC,LPRECT,MONITORENUMPROC,LPARAM);
		(FARPROC&)pEnumDisplayMonitors = ::GetProcAddress(::LoadLibrary("user32.dll"), "EnumDisplayMonitors");
		if ( pEnumDisplayMonitors==NULL ) {
			is_single_monitor = true;
		}
		else {
			(*pEnumDisplayMonitors)(NULL,NULL,(MONITORENUMPROC)MonitorEnumFunc,(LPARAM)(&max_screen_rect));
			::GetWindowRect(::GetDesktopWindow(), &desktop_rect);
			RECT*	rect;
			rect = &desktop_rect;
			sender << "vC}fXNgbv: (" << 
				rect->left << "," << rect->top << "," << rect->right << "," << rect->bottom << ")" << endl;
			rect = &max_screen_rect;
			sender << "zfXNgbv: (" << 
				rect->left << "," << rect->top << "," << rect->right << "," << rect->bottom << ")" << endl;
			is_single_monitor = ( ::EqualRect(&max_screen_rect, &desktop_rect)!=FALSE );
			sender << (is_single_monitor ? 
				"j^͈ƔfA؂ꔻĂяoɔC܂B" : 
				"̃j^ڑĂƔfA؂ꔻ͗Xs܂B") << endl;
		}
	}
#endif // _MSC_VER

	// uǂݎ
	strmap_from_file(replace_before_dic, mBaseFolder+"replace.txt", "\t");
	strmap_from_file(replace_after_dic, mBaseFolder+"replace_after.txt", "\t");

	// Lf[^ǂݍ
	mCharacters.load(mBaseFolder + "characters.ini");
	for ( inimap::const_iterator i=mCharacters.begin() ; i!=mCharacters.end() ; ++i ) {
		const strmap& m = i->second;
		strmap::const_iterator j;

		// uɒǉ
		j = m.find("popular-name");
		if ( j != m.end() && j->second.size()>0 ) 
			replace_before_dic[j->second + "F"] = string() + "\\p[" + i->first + "]";
		j = m.find("initial-letter");
		if ( j != m.end() && j->second.size()>0 ) 
			replace_before_dic[j->second + "F"] = string() + "\\p[" + i->first + "]";

		j = m.find("base-surface");
		if ( j != m.end() && j->second.size()>0 )
			system_variable_operation( string("T[tFXZl") + i->first, j->second);
	}

	//for ( strmap::const_iterator j=replace_before_dic.begin() ; j!=replace_before_dic.end() ; ++j )
	//	cout << j->first << ": " << j->second << endl;

	// _}CY
	randomize(time(NULL));


	//------------------------------------------

	// RtBOǂݍ
	LoadDictionary(mBaseFolder + "satori_conf.txt");

	// ϐs
	GetSentence("");	

	// SAORIǂݍ
	Family<Word>* f = words.get_family("SAORI");
	if ( f != NULL )
	{
		list<const Word*> els;
		f->get_elements_pointers(els);

		mShioriPlugins.load(mBaseFolder);
		for ( list<const Word*>::const_iterator i=els.begin(); i!=els.end() ; ++i)
		{
			if ( (*i)->size()>0 && !mShioriPlugins.load_a_plugin(**i) )
			{
				sender << "SAORIǂݍݒɃG[: " << **i << endl;
			}
		}
	}
	talks.clear();
	words.clear();

	//------------------------------------------

	// Z[uf[^ǂݍ
	LoadDictionary(mBaseFolder + "satori_savedata.txt");

	GetSentence("Z[uf[^");
	talks.clear();
	
	reload_flag = false;

	tick_count_total = stoi(variables["S[XgNԗ݌v(ms)"]);
	variables["N"] = itos( stoi(variables["N"])+1 );

	// uP̒ǉvœo^ꂽPoĂ
	const map< string, Family<Word> >& m = words.compatible();
	for ( map< string, Family<Word> >::const_iterator it = m.begin() ; it != m.end() ; ++it )
	{
		vector<const Word*> v;
		it->second.get_elements_pointers(v);
		mAppendedWords[it->first] = v;
	}

	//------------------------------------------

	// wtH_̎ǂݍ
	strvec::iterator i = dic_folder.begin();
	if ( i==dic_folder.end() ) {
		LoadDicFolder(mBaseFolder);	// [gtH_̎
	} else {
		for ( ; i!=dic_folder.end() ; ++i )
			LoadDicFolder(mBaseFolder + *i + DIR_CHAR);	// TutH_̎
	}

	//------------------------------------------

	secure_flag = true;

	system_variable_operation("PQuv̏d", "LAg[N");
	system_variable_operation("g[Nuv̏d", "L");
	//system_variable_operation("PQuG߂̐Hוv̏d", "LAg[N");

	GetSentence("OnSatoriLoad");
	on_loaded_script = GetSentence("OnSatoriBoot");
	diet_script(on_loaded_script);

	sender << "loaded." << endl;
	return	true;
}


//---------------------------------------------------------------------------
#define	ENCODE(x)	(fEncodeSavedata ? encode(encode(x)) : (x))

#ifdef POSIX
#  include <time.h>
#endif
bool	Satori::Save(bool isOnUnload) {

	// oϐ𗢁Xϐ
	for (map<int, string>::iterator it=reserved_talk.begin(); it!=reserved_talk.end() ; ++it)
		variables[string("")+itos(it->first)+"ڂ̃g[N"] = it->second;
	// Nԗ݌vݒ
#ifdef POSIX
	variables["S[XgNԗ݌v(ms)"] =
	    itos(posix_get_current_millis() - tick_count_at_load + tick_count_total);
#else
	variables["S[XgNԗ݌v(ms)"] = itos( ::GetTickCount() - tick_count_at_load + tick_count_total );
#endif

	if ( isOnUnload ) {
		secure_flag = true;
		(void)GetSentence("OnSatoriUnload");
	}

	string	theFullPath = mBaseFolder + "satori_savedata." + (fEncodeSavedata?"sat":"txt");
	ofstream	out(theFullPath.c_str());
	bool	temp = Sender::is_validated();
	Sender::validate();
	sender << "saving " << theFullPath << "... " ;
	Sender::validate(temp);
	if ( !out.is_open() )
	{
		sender << "failed." << endl;
		return	false;
	}
	string	line = "Z[uf[^";
	out << ENCODE(line) << endl;
	for (strmap::const_iterator it=variables.begin() ; it!=variables.end() ; ++it) {
		string	zen2han(string str);
		string	str = zen2han(it->first);
		if ( str[0]=='S' && aredigits(str.c_str()+1) )
			continue;
		string	line = string("")+it->first+"\t"+it->second; // ϐۑ
		out << ENCODE(line) << endl;
	}

	for ( map<string, vector<const Word*> >::const_iterator i=mAppendedWords.begin() ; i!=mAppendedWords.end() ; ++i )
	{
		out << endl << ENCODE( string("") + i->first ) << endl;
		for ( vector<const Word*>::const_iterator j=i->second.begin() ; j!=i->second.end() ; ++j )
		{
			out << ENCODE(**j) << endl;
		}
	}

	sender << "ok." << endl;
	return	true;
}

//---------------------------------------------------------------------------
bool	Satori::unload() {

	// t@Cɕۑ
	this->Save(true);

	// vOC
	mShioriPlugins.unload();

	sender << "SATORI::Unload ---------------------" << endl;
	return	true;
}

