#include	"satori.h"

#include	<fstream>
#include	<cassert>
#ifdef POSIX
#  include      "Utilities.h"
#else
#  include	<mbctype.h>
#endif

void	diet_script(string& ioScript) {
	replace(ioScript, "\\h", "\\0");
	replace(ioScript, "\\u", "\\1");
	erase(ioScript, "\\_w[0]");
	int	count;
	do {
		count=0;
		count += replace(ioScript, "\\1\\0", "\\0");
		count += replace(ioScript, "\\0\\0", "\\0");
		count += replace(ioScript, "\\0\\1", "\\1");
		count += replace(ioScript, "\\1\\1", "\\1");
		count += replace(ioScript, "\\n\\e", "\\e");
		count += replace(ioScript, "\\n[half]\\e", "\\e");
		count += replace(ioScript, "\\n\\-", "\\-");
		count += replace(ioScript, "\\n[half]\\-", "\\-");
		count += replace(ioScript, "\\e\\-", "\\-");
		count += replace(ioScript, "\\e\\e", "\\e");
	} while (count>0);

	while ( compare_tail(ioScript, "\\n") )
		ioScript.assign(ioScript.substr(0, ioScript.size()-2));
}

bool	Satori::FindEventTalk(string& ioevent) {

	static	strmap	replace_map;
	static	bool	isinit=false;
	if ( !isinit ) {
		replace_map["OnBoot"]="N";
		replace_map["OnClose"]="I";
		replace_map["OnFirstBoot"]="";
		replace_map["OnGhostChanged"]="̃S[XgύX";
		replace_map["OnGhostChanging"]="̃S[Xg֕ύX";
		//replace_map["OnMouseDoubleClick"]="OnTalk";
		replace_map[""]="OnBoot";
		replace_map["̃S[XgύX"]="OnBoot";
		replace_map["̃S[Xg֕ύX"]="OnClose";
		replace_map["OnVanishSelecting"]="Ŏw";
		replace_map["OnVanishCancel"]="œP";
		replace_map["OnVanishSelected"]="Ō";
		replace_map["OnVanishButtonHold"]="Œf";
		replace_map["OnTalk"]="";
		//replace_map[""]="";
		isinit = true;
	}

	while (true) {
		if ( talks.is_exist(ioevent) )
			return	true;	// Cxg݁AɌ
		if ( replace_map.find(ioevent) == replace_map.end() )
			return	false;	// uΏۂ
		sender << "event replaced " << ioevent <<  "  " <<  replace_map[ioevent] << endl;
		ioevent = replace_map[ioevent];
	}
}




string	Satori::GetSentence(const string& name) {
	string	accumulater, script, sentence=name;
	while ( GetSentence(sentence, script) )
		accumulater += script;
	accumulater += script;
	return	accumulater;
}



// }EFCg
#define	character_wait_clear	\
	if ( mRequestID == "OnHeadlinesense.OnFind" ) { characters = 0;	} \
	else if( characters > 0 ) { \
		result += string("\\_w[") + itos( int(characters*basewait*rate_of_auto_insert_wait/100) ) + "]"; characters=0; \
	} else NULL

string	Satori::SentenceToSakuraScript(const strvec& vec) {

	// ċAǗ
	static	int nest_count=0;
	++nest_count;
	//DBG(sender << "enter SentenceToSakuraScript, nest-count: " << nest_count << ", vector_size: " << vec.size() << endl);


	if ( nest_count==1 ) {
		question_num=0;	// Iԍ
		speaked_speaker.clear(); // łǂ
		surface_changed_before_speak.clear(); // bOɃT[tFX؂芷w
		characters = 0;	// 
	}
	kakko_replace_history.push(strvec()); // JbȒOQƗp

	static const int basewait=3;
	string	result;

	result = "\\1";
	speaker = 1;	// {̂ 0 ɂイ 1

	strvec::const_iterator it = vec.begin();
	for ( ; it != vec.end() ; ++it) {
		const char*	p = it->c_str();
		//DBG(sender << nest_count << " '" << p << "'" << endl);

		if ( it==vec.begin() && strncmp(p, "", 2)==0 ) {
			p+=2;

			if ( ghosts_info.size()>=2 ) {	// ȊOɃS[Xg͂̂B
				string	temp = p;
				vector<strmap>::iterator i=ghosts_info.begin(); ++i; // ͔΂
				for ( ; i!=ghosts_info.end() ; ++i ) { 
					string	name = (*i)["name"];
					sender << "ghost: " << name <<endl;
					if ( compare_head(temp, name) ) {// 
						mCommunicateFor = name;
						p += mCommunicateFor.size();
					}
				}
				if ( i==ghosts_info.end() ) {	// 肵Ȃꍇ
					// _
					//int n = (random()%(ghosts_info.size()-1))+1;
					//assert( n>=1 && n < ghosts_info.size());
					mCommunicateFor = (ghosts_info[1])["name"];

					// AׂŋNĂ``ɂȂ
				}
			}
		}

		// I	\q?[id,string]
		if ( strncmp(p, "Q", 2)==0 ) {
			if ( strlen(p)>1023 )
				continue;
			char	buf[1024];
			strcpy(buf, p+2);

			char*	choiced = buf;
			char*	id = strstr(buf, "\t"); // IxƃWv̋؂
			if ( id == NULL ) {
				string	str=UnKakko(choiced);
				//result += string("\\q")+itos(question_num++)+"["+str+"]["+str+"]";
				result += string("\\q")+"["+str+","+str+"]\\n";
			} else {
				*id++='\0';
				while ( *id=='\t' ) ++id; // IxƃWv̋؂
				//result += string("\\q")+itos(question_num++)+"["+UnKakko(id)+"]["+UnKakko(choiced)+"]";
				result += "\\q["+UnKakko(choiced)+","+UnKakko(id)+"]\\n";
			}
			continue;
		}

		// Ɣȑ݈Ӌ`B
		if ( strncmp(p, "\\s", 2)==0 ) {	
			if ( !is_speaked(speaker) )
				surface_changed_before_speak.insert(speaker);
		}

		// Wv
		if ( strncmp(p, "", 2)==0 || strncmp(p, "", 2)==0 ) {
			strvec	words;
			split(p+2, "\t", words); // WvƃWv̋؂
			string	jump_to="";
			if ( words.size()>=1 ) {
				jump_to = UnKakko(words[0].c_str());
				if ( words.size()>=2 ) {
					string	r;
					if ( !calculate(words[1], r) )
						break;
					if ( r=="0" || r=="O" )
					{
						sender << "vZʂO߁As܂B" << endl;
						continue;
					}
				}
			}

			if ( strncmp(p, "", 2)==0 ) {

				string	script;
				if ( TalkSearch(jump_to, script, (mRequestID!="OnCommunicate") ) ) {
					result += script;
					break;	// ̃tF[Y͏I
				}
				sender << "" << jump_to << " not found." << endl;
			}
			else if ( talks.is_exist(jump_to) ) {
				sender << "" << jump_to << "" << endl;
				result += GetSentence(jump_to);
				break;	// ̃tF[Y͏I
			} 
			else {
				sender << "" << jump_to << " not found." << endl;
			}
			continue;
		}

		// ϐݒ
		if ( strncmp(p, "", 2)==0 ) {
			const char* v;
			string	value;
			bool	do_calc=false;
			p+=2;
			if ( (v=strstr(p, "\t"))!=NULL ) { // ϐƕϐɐݒ肷e̋؂
				value = UnKakko(v+1);
			}
			else if ( (v=strstr(p, ""))!=NULL || (v=strstr(p, "="))!=NULL ) {
				value = UnKakko(v+((*v=='=') ? 1 : 2));
				do_calc=true;
			}
			else {
				//v = p+strlen(p);
				//value="";
				result += "\\n@ɂϐɂ́A^uɂ؂肩AɂvZKvł@\\n\\n[half]'" + value +"'";
				break;
			}

			string	key(p, v-p);
			key = UnKakko(key.c_str());

			if ( key=="" ) {
				result += ""; // ̂܂ܕ\
			}
			else if ( aredigits(zen2han(key)) ) {
				sender << "" << key << "@݂̂̕ϐ͈܂." << endl;
				erase_var(key);	// ݖ
			}
			else if ( value=="" ) {
				sender << "" << key << "^cleared." << endl;
				erase_var(key);	// ݖ
			}
			else {

				if ( do_calc ) {
					// ɎQƂ鎞AG[ԂȂ悤ɁB
					variables[key] = "0";	

					if ( !calculate(value, value) )
						break;
					if ( aredigits(value) ) {
						value = int2zen(stoi(value));
					}
				}

				sender << "" << key << "" << value << "^" << 
					(( variables.find(key) == variables.end() ) ?
					"writed." : "overwrited.")<< endl;

				variables[key] = value;
				system_variable_operation(key, value, &result);
			}
			continue;
		}

		// ʏ폈
		while ( p[0] != '\0' ) {
			string	c=get_a_chr(p);	// Spp킸ꕶ擾Apꕶ߂

			if ( c=="i" ) {	// 擾E}
				string	tmp = KakkoSection(p);
				result += tmp;
			}
			else if ( c=="F" ) {	// XR[v؂ւ - ͓lzB
				if ( is_speaked(speaker) ) {
					result += append_at_scope_change;
					characters += 2;
				}
				speaker = (speaker==0) ? 1 : 0;
				character_wait_clear;
				result += (speaker ? "\\1" : "\\0");
			}
			else if ( c=="\\" || c=="%" ) {	// XNvg̉߁AƂ߂̃XLbvB

				if (*p=='\\'||*p=='%') {	// GXP[vꂽ\, %
					result += c + *p++;
					continue;
				}

				const char*	start=p;
				string	cmd="",opt="";

				while (!_ismbblead(*p) && (isalpha(*p)||isdigit(*p)||*p=='!'||*p=='*'||*p=='&'||*p=='?'||*p=='_'))
					++p;
				cmd.assign(start, p-start);

				if (*p=='[') {
					const char* opt_start = ++p;
					while (*p!=']') {
						if (p[0]=='\\' && p[1]==']')	// GXP[vꂽ]
							++p;
						p += _ismbblead(*p) ? 2 : 1;
					}
					opt.assign(opt_start, p++ -opt_start);
					opt=UnKakko(opt.c_str());
				}

				if ( cmd=="n" ) {
					// s
					character_wait_clear;
				}
				else if ( (cmd=="0" && speaker==1) || (cmd=="1" && speaker==0) ) {
					// XR[v؂ւ
					if ( is_speaked(speaker) ) {
						result += append_at_scope_change_with_sakura_script;
						characters += 2;
					}
					speaker = stoi(cmd);
					character_wait_clear;
				}
				else if ( cmd=="p" && aredigits(opt) ) {
					// XR[v؂ւonSSP/CROW
					if ( is_speaked(speaker) ) {
						result += append_at_scope_change_with_sakura_script;
						characters += 2;
					}
					speaker = stoi(opt);
					character_wait_clear;
				}

				if ( opt!="" ) {
					//sender << "ss_cmd: " << c << "," << cmd << "," << opt << endl;
					result += c + cmd + "[" + opt + "]";
				} else {
					//sender << "ss_cmd: " << c << "," << cmd << endl;
					result += c + cmd;
				}


				//result += string(start, p-start);
			}
			else {	// ʏ̈ꕶ
				speaked_speaker.insert(speaker);
				result += c;
				characters += c.size();
				if ( c=="B" || c=="A" )
					character_wait_clear;
			}

		}
		character_wait_clear;
		result += "\\n";
	}

	kakko_replace_history.pop(1);
	//DBG(sender << "leave SentenceToSakuraScript, nest-count: " << nest_count << endl);
	--nest_count;
	return	result;
}

#undef	DBG
#define	DBG(a)	a

// w肳ꂽOɊY₩烉_ňIсA
// XNvgɓWJĕԂB
// ċAJEgĂ̂ŕspӂreturn͌ցB
bool	Satori::GetSentence(string& ioSentenceName, string& oResultScript) {
	// ċAǗ
	static	int nest_count=0;
	++nest_count;

	// _g[N\񂳂Ăꍇ̓ꏈBP̃g[NłP񂾂B
	static	bool	reserved_talk_processed;
	if ( nest_count==1 )
		reserved_talk_processed=false;
	if ( !reserved_talk_processed && (ioSentenceName=="" || ioSentenceName=="OnTalk") )
	{
		reserved_talk_processed = true;

		string	reserved_talk_name;	// bׂg[N΁A̖OɂȂ
		if ( !reserved_talk.empty() ) {
			// \g[N̓Y1fNg
			map<int, string>::iterator	it = reserved_talk.begin();
			while ( it!=reserved_talk.end() )
			{
				reserved_talk[it->first-1] = it->second;
				reserved_talk.erase(it++);
			}

			// 擪̃g[NbׂɂȂĂ΁AO擾AL[AEgB
			it=reserved_talk.begin();
			if ( it->first<=0 ) {
				reserved_talk_name = it->second;
				reserved_talk.erase(it);	// ͍̂폜
			}
		}

		if ( ioSentenceName=="OnTalk" && talks.is_exist("OnTalk") ) {	
			// OnTalkłA`Ăꍇ
			if ( reserved_talk_name.empty() ) {	// bׂg[N͂Ȃ_g[Nł
				mRequestMap["Reference0"]=mReferences[0]="0";
				mRequestMap["Reference1"]=mReferences[1]="";
			}
			else {	// Abׂ\g[N݂
				mRequestMap["Reference0"]=mReferences[0]="1";
				mRequestMap["Reference1"]=mReferences[1]=reserved_talk_name;
			}
		}
		else {
			// AOnTalkłƂĂ`ĂȂꍇ
			if ( !reserved_talk_name.empty() )	// Abׂ\g[N݂
				ioSentenceName = reserved_talk_name;	// Cxg\g[NŒu
		}
	}

	// mapw薼g[NQ
	sender << "" << ioSentenceName;
	const Talk* talk = talks.select(ioSentenceName, *this);
	if ( talk == NULL )
	{
		sender << " not matched." << endl; // Ɉv̂ȂB
		--nest_count;
		return	false;
	}
	sender << endl;

	// g[NXNvgɕϊ
	{
		Sender::nest_object smo(2); 
		oResultScript = SentenceToSakuraScript(*talk);
		sender << "return: " << oResultScript << "" << endl;
	}

	--nest_count;
	return	false;
}
