#ifdef POSIX
#  include      "Utilities.h"
#  include      <iostream>
#  include      <stdlib.h>
#  include      <sys/types.h>
#  include      <sys/stat.h>
#  include      <dlfcn.h>
#else
#  include	<windows.h>
#  include	<mbctype.h>
#endif
#include	<assert.h>
#include	"../_/stltool.h"
#include	"../_/sender.h"
#include	"shiori_plugin.h"
#include	"console_application.h"
#include	<sstream>
using namespace std;

// ǂɂ
void	PluginError(const string& str)
{
#ifdef POSIX
        cerr << "error - SAORI : " << str << endl;
#else
	::MessageBox(NULL, str.c_str(), "error - SAORI", MB_OK|MB_SYSTEMMODAL);
#endif
}

#ifdef POSIX
// dllT[`pX֘AB
// POSIXł́ȀꏊDLLƓ̃CuuSAORIɑΉB
// DLLƓƂ͉]ĂA̓V{bNNłׂŁAႦΎ̂悤ɂłB
// % pwd
// /home/foo/.saori
// % ls -l
// -rwxr-xr-x x foo bar xxxxx 1 1 00:00 libssu.so
// lrwxr-xr-x x foo bar xxxxx 1 1 00:00 ssu.dll -> libssu.so
//
// pX͊ϐ SAORI_FALLBACK_PATH 擾B̓R؂̐΃pXłB
static vector<string> posix_dll_search_path;
static bool posix_dll_search_path_is_ready = false;
static string posix_search_fallback_dll(const string& dllfile) {
    // dllfile͒Tt@CDLLBpX؂蕶/B
    // փCut΂̐΃pXA
    // tȂ΋󕶎ԂB
    
    if (!posix_dll_search_path_is_ready) {
	// SAORI_FALLBACK_PATHB
	char* cstr_path = getenv("SAORI_FALLBACK_PATH");
	if (cstr_path != NULL) {
	    split(cstr_path, ":", posix_dll_search_path);
	}
	posix_dll_search_path_is_ready = true;
    }

    string::size_type pos_slash = dllfile.rfind('/');
    string fname(
	dllfile.begin() + (pos_slash == string::npos ? 0 : pos_slash),
	dllfile.end());

    for (vector<string>::const_iterator ite = posix_dll_search_path.begin();
	 ite != posix_dll_search_path.end(); ite++ ) {
	string fpath = *ite + '/' + fname;
	struct stat sb;
	if (stat(fpath.c_str(), &sb) == 0) {
	    // փCu݂悤Bȏ̃`FbN͏ȗB
	    return fpath;
	}
    }
    return string();
}
#endif

bool ShioriPlugins::load(const string& iBaseFolder)
{
	mBaseFolder = iBaseFolder;

	// mBaseFolderXbVŏIĂȂ΁AtB
	if ( false == mBaseFolder.empty() && mBaseFolder[mBaseFolder.length() - 1] != DIR_CHAR)
	{
	    mBaseFolder += DIR_CHAR;
	}
	return true;
}

bool ShioriPlugins::load_a_plugin(const string& iPluginLine)
{
	strvec	vec;
	split(iPluginLine, ",", vec);	// J}؂ŕ
	if ( vec.size()<2 || vec[0].size()==0 ) {	// ĂяoƑ΃pXK{
		PluginError(iPluginLine + ": ݒt@C̏܂B");
		return	false;
	}
	if ( mCallData.find(vec[0]) != mCallData.end() ) {
		PluginError(vec[0] + ": Ăяo`Ă܂B");
		return	false;
	}

	// tH_؂ɉĕɓ
	string filename = unify_dir_char(vec[1]);
	string fullpath = unify_dir_char(mBaseFolder + filename);

	if ( mDllData.find(fullpath) != mDllData.end() ) 
	{
		// ɓo^ς݂ȂQƂ𑝂₷
		mDllData[fullpath].mRefCount += 1;
	}
	else 
	{
		// o^Ȃǂݍ

#ifndef POSIX
		// lbg[NXVASAORI.dll㏑łdl2ƂĕۑɎbΏ
		if ( compare_tail(fullpath, ".dll") )
		{
			string	dl2 = fullpath;
			dl2[dl2.size()-1]='2';
			FILE*	fp = fopen(dl2.c_str(), "rb");
			if ( fp != NULL )
			{
				fclose(fp);
				
				// .dll.dl2.dllɃl[B
				::DeleteFile(fullpath.c_str());
				::MoveFile(dl2.c_str(), fullpath.c_str());
			}
		}
#endif
		
		// t@C݂̑mF
		FILE*	fp = fopen(fullpath.c_str(), "rb");
		if ( fp == NULL )
		{
#ifdef POSIX
            PluginError(fullpath + ": failed to open");
#else
			PluginError(fullpath + ": vOC݂܂B");
#endif
			return	false;
		}
		fclose(fp);

		// t@CEtH_Egq𕪗
		const char*	lastyen = NULL;
		const char*	lastdot = NULL;
		const char*	p = fullpath.c_str();
		while (*p != '\0') {
			if (*p == DIR_CHAR)
				lastyen=p;
			else if (*p == '.')
				lastdot=p;
			p += _ismbblead(*p) ? 2 : 1; 
		}
		if ( lastyen==NULL || lastdot==NULL )
		{
			return false;
		}

		string  dll_full_path(fullpath);
		string	foldername(fullpath.c_str(), lastyen - fullpath.c_str());
		string	filename(lastyen+1, strlen(lastyen)-strlen(lastdot)-1);
		string	extention(lastdot+1);

#ifdef POSIX
		// ϐ SAORI_FALLBACK_ALWAYS `ĂāA
		// ł"0"łȂ΁Adllt@CJĂ݂鎖
		// ߂ȂBłȂ΁AdlopenĂ݂B
		char* env_fallback_always = getenv("SAORI_FALLBACK_ALWAYS");
		bool fallback_always = false;
		if (env_fallback_always != NULL) {
		    string str_fallback_always(env_fallback_always);
		    if (str_fallback_always.length() > 0 &&
			str_fallback_always != "0") {
			fallback_always = true;
		    }
		}
		bool do_fallback = true;
		if (!fallback_always) {
		    void* handle = dlopen(fullpath.c_str(), RTLD_LAZY);
		    if (handle != NULL) {
			// load, unload, requestoĂ݂B
			void* sym_load = dlsym(handle, "load");
			void* sym_unload = dlsym(handle, "unload");
			void* sym_request = dlsym(handle, "request");
			if (sym_load != NULL && sym_unload != NULL && sym_request != NULL) {
			    // ȂƐɓǂ߂Ă܂BړIō낤B
			    do_fallback = false;
			}
		    }
		    dlclose(handle);
		}
		if (do_fallback) {
		    // փCuTB
		    string fallback_lib = posix_search_fallback_dll(filename+"."+extention);
		    if (fallback_lib.length() == 0) {
			// B
			char* cstr_path = getenv("SAORI_FALLBACK_PATH");
			string fallback_path =
			    (cstr_path == NULL ?
			     "(environment variable `SAORI_FALLBACK_PATH' is empty)" : cstr_path);
			PluginError(
			    fullpath+": This is not usable in this platform.\n"+
			    "Fallback library `"+filename+"."+extention+"' doesn't exist: "+fallback_path);
			mDllData.erase(fullpath);
			return false;
		    }
		    else {
			cerr << "SAORI: using " << fallback_lib << " instead of " << fullpath << endl;
		    }

		    // QƃJEgɎg߁Afullpath͏ȂB
		    // dll_full_patĥ݁B
		    dll_full_path = fallback_lib;
		}
#endif

		// POSIXł́ACu*.dllȊOB
#ifdef POSIX
		if ( 1 )
#else
		if ( compare_tail(fullpath, ".dll") )
#endif
		{
			// vOCDLL[h
			mDllData[fullpath].mRefCount=1;
			extern const char* gSatoriName;
			if ( !(mDllData[fullpath].mSaoriClient.load(gSatoriName, "Shift_JIS", foldername+DIR_CHAR, dll_full_path)) )
			{
				mDllData.erase(fullpath);
				return	false;
			}

			// o[WmF
			string ver = mDllData[fullpath].mSaoriClient.get_version("Local");
			if ( ver != "SAORI/1.0" )
			{
				PluginError(fullpath + ": SAORI/1.0dllł͂܂BGET Version̖߂lΉ̂̂łB(" + ver + ")");
				mDllData.erase(fullpath);
				return	false;
			}
		}
	}

	// Ăяomapɓo^
	mCallData[vec[0]].mDllPath = fullpath;
#ifdef POSIX
	mCallData[vec[0]].mIsBasic = false; // gqł͔fłȂ̂ŁAƂ肠Saori Basic̃T|[g͖c
#else
	mCallData[vec[0]].mIsBasic = !compare_tail(fullpath, ".dll");
#endif
	strvec::const_iterator j=vec.begin();
	for ( j+=2 ; j!=vec.end() ; ++j )
		mCallData[vec[0]].mPreDefinedArguments.push_back(*j);

	return	true;
}

void	ShioriPlugins::unload()
{
	for ( map<string, CallData>::iterator i=mCallData.begin() ; i!=mCallData.end() ; ++i ) {
		if ( i->second.mIsBasic )
			continue;
		DllData&	ddat = mDllData[i->second.mDllPath];
		if ( --ddat.mRefCount == 0 ) {
			ddat.mSaoriClient.unload();
			mDllData.erase(i->second.mDllPath);
		}
	}
	mCallData.clear();
}

string	ShioriPlugins::request(const string& iCallName, const strvec& iArguments, strvec& oResults, const string& iSecurityLevel) {

	if ( mCallData.find(iCallName) == mCallData.end() ) {
		PluginError(iCallName + ": ̌Ăяo͒`Ă܂B");
		return	"";
	}
	CallData&	theCallData = mCallData[iCallName];

	if ( theCallData.mIsBasic ) 
	{
		// SAORI-basičĂяo

		// ׁ[externalĂяo𔻕ʂ\͂̂Łiϐœn΂Hj
		// ̎_őSĐ؂܂B-universal̓NGXgsecurity levelwb_nASAORIŔʂĂ܂B
		if ( iSecurityLevel != "local" && iSecurityLevel != "Local" )
			return	""; 

		string	theCommandLine = theCallData.mDllPath;
		strvec::const_iterator i;
		for ( i=theCallData.mPreDefinedArguments.begin() ; i!=theCallData.mPreDefinedArguments.end() ; ++i )
			theCommandLine += " "+ *i;
		for ( i=iArguments.begin() ; i!=iArguments.end() ; ++i )
			theCommandLine += " "+ *i;

		string out;
		string r = call_console_application(
			theCommandLine,
			get_folder_name(theCallData.mDllPath).c_str(),
			out);
		if ( r != "" )
		{
			// G[
			PluginError(iCallName + ": " + r);
			return "";
		}
		else
		{
			// I
			return out;
		}
	}
	else 
	{
		// SAORI-universaľĂяo

		//---------------------
		// NGXg쐬

		vector<string> req;
		req.insert(req.end(), theCallData.mPreDefinedArguments.begin(), theCallData.mPreDefinedArguments.end());
		req.insert(req.end(), iArguments.begin(), iArguments.end());

		//---------------------
		// NGXgs

		assert( mDllData.find(theCallData.mDllPath) != mDllData.end() );

		string result;
		int return_code = mDllData[ theCallData.mDllPath ].mSaoriClient.request(
			 req,
			 ( iSecurityLevel == "local" || iSecurityLevel == "Local" ),
			 result,
			 oResults);

		//---------------------
		// ԓɑΏ

		switch (return_code)
		{
		case 200:
		case 204:
			break;
		case 400:
			PluginError(theCallData.mDllPath + ": 400 Bad Request / Ăяo̕s");
			break;
		case 500:
			PluginError(theCallData.mDllPath + ": 500 Internal Server Error / saorił̃G[");
			break;
		default:
			PluginError(theCallData.mDllPath + ": " + itos(return_code) + "? / `ĂȂXe[^XԂ܂B");
			break;
		}

		return	result;
	}
}


